## bluebrain-hpc-coding-conventions 1.0.0+git20221201

=== Makefile ===
subdirs = cpp

all clean distclean:
	$(foreach dir,$(subdirs),$(MAKE) -C $(dir) $(MAKEFLAGS) $@;)
