=== debian/changelog ===
bluebrain-hpc-coding-conventions (1.0.0+git20221201-2) unstable; urgency=medium

  * Don't install .gitignore file

 -- Matthias Klumpp <mak@debian.org>  Fri, 03 Feb 2023 10:34:22 +0100

bluebrain-hpc-coding-conventions (1.0.0+git20221201-1) unstable; urgency=medium

  * Initial release

 -- Matthias Klumpp <mak@debian.org>  Thu, 26 Jan 2023 16:06:02 +0100
