=== debian/control ===
Source: bluebrain-hpc-coding-conventions
Section: science
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Matthias Klumpp <mak@debian.org>
Build-Depends: clang-format,
               clang-tidy,
               cmake-format,
               debhelper-compat (= 13),
               pre-commit,
               python3,
               python3-yaml
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/BlueBrain/hpc-coding-conventions
Vcs-Git: https://salsa.debian.org/science-team/bluebrain-hpc-coding-conventions.git
Vcs-Browser: https://salsa.debian.org/science-team/bluebrain-hpc-coding-conventions

Package: bluebrain-hpc-coding-conventions
Architecture: all
Depends: clang-format,
         clang-tidy,
         cmake-format,
         pre-commit,
         python3,
         python3-yaml,
         ${misc:Depends},
         ${shlibs:Depends}
Description: BlueBrain HPC Team C++ Development Guidelines
 This package contains tools and processes required to ensure the
 C++ development guidelines adopted by the BlueBrain HPC team
 are followed. It also contains their documentation.
 .
 This package is used in the build process of tools created by the
 BlueBrain project.
