=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_clean:
	:

override_dh_auto_build:
	:

override_dh_install:
	dh_install

	rm $(CURDIR)/debian/bluebrain-hpc-coding-conventions/usr/share/bluebrain-hpc-coding-conventions/cpp/formatting/.gitignore
