=== debian/watch ===
version=4

https://github.com/BlueBrain/hpc-coding-conventions/tags .*/@ANY_VERSION@\.tar\.gz
